From 36f36c3ad8febb444eb4f7158e6b26588e1149c6 Mon Sep 17 00:00:00 2001
From: Nisar Sayed <Nisar.Sayed@microchip.com>
Date: Fri, 26 May 2017 00:06:22 +0530
Subject: [PATCH 06/12] fixed phy support to lan78xx

---
 drivers/net/phy/fixed.c   |  5 +++++
 drivers/net/usb/Kconfig   |  1 +
 drivers/net/usb/lan78xx.c | 49 +++++++++++++++++++++++++++++++++++++++++++----
 3 files changed, 51 insertions(+), 4 deletions(-)

diff --git a/drivers/net/phy/fixed.c b/drivers/net/phy/fixed.c
index 85eaed1..26871dc 100644
--- a/drivers/net/phy/fixed.c
+++ b/drivers/net/phy/fixed.c
@@ -277,6 +277,11 @@ EXPORT_SYMBOL_GPL(fixed_phy_register);
 
 void fixed_phy_unregister(struct phy_device *phy)
 {
+	if (phy_fixed_addr > 0)
+		phy_fixed_addr--;
+	else
+		return;
+
 	phy_device_remove(phy);
 
 	fixed_phy_del(phy->addr);
diff --git a/drivers/net/usb/Kconfig b/drivers/net/usb/Kconfig
index 1ea43c9..e3ebff9 100644
--- a/drivers/net/usb/Kconfig
+++ b/drivers/net/usb/Kconfig
@@ -145,6 +145,7 @@ config USB_LAN78XX
         select MII
         select PHYLIB
         select MICROCHIP_PHY
+        select FIXED_PHY
         help
           This option adds support for Microchip LAN78XX based USB 2
           & USB 3 10/100/1000 Ethernet adapters.
diff --git a/drivers/net/usb/lan78xx.c b/drivers/net/usb/lan78xx.c
index c0b1d3b..7f1859d 100644
--- a/drivers/net/usb/lan78xx.c
+++ b/drivers/net/usb/lan78xx.c
@@ -36,6 +36,7 @@
 #include <linux/irqchip/chained_irq.h>
 #include <linux/microchipphy.h>
 #include <linux/phy.h>
+#include <linux/phy_fixed.h>
 #include <linux/version.h>
 #include "lan78xx.h"
 
@@ -2078,6 +2079,14 @@ static int ksz9031rnx_fixup(struct phy_device *phydev)
 	return 1;
 }
 
+static struct fixed_phy_status fphy_status = {
+	.link = 1,
+	.speed = SPEED_1000,
+	.duplex = DUPLEX_FULL,
+};
+
+static bool fixed_phy_device_present;
+
 static int lan78xx_phy_init(struct lan78xx_net *dev)
 {
 	int ret;
@@ -2086,8 +2095,34 @@ static int lan78xx_phy_init(struct lan78xx_net *dev)
 
 	phydev = phy_find_first(dev->mdiobus);
 	if (!phydev) {
-		netdev_err(dev->net, "no PHY found\n");
-		return -EIO;
+		if (dev->chipid == ID_REV_CHIP_ID_7801_) {
+			u32 buf;
+
+			phydev = fixed_phy_register(PHY_POLL, &fphy_status,
+						    NULL);
+			if (IS_ERR(phydev)) {
+				netdev_err(dev->net, "fixed PHY register failed\n");
+				return -EIO;
+			}
+			netdev_info(dev->net, "registered fixed PHY\n");
+			netdev_info(dev->net, "KSZ9897 IBA Switch device\n");
+
+			fixed_phy_device_present = true;
+			dev->interface = PHY_INTERFACE_MODE_RGMII;
+
+			ret = lan78xx_write_reg(dev, MAC_RGMII_ID,
+						MAC_RGMII_ID_TXC_DELAY_EN_);
+			ret = lan78xx_write_reg(dev, RGMII_TX_BYP_DLL, 0x3D00);
+			ret = lan78xx_read_reg(dev, HW_CFG, &buf);
+			buf |= HW_CFG_CLK125_EN_;
+			buf |= HW_CFG_REFCLK25_EN_;
+			ret = lan78xx_write_reg(dev, HW_CFG, buf);
+			goto phyinit;
+
+		} else {
+			netdev_err(dev->net, "no PHY found\n");
+			return -EIO;
+		}
 	}
 
 	if ((dev->chipid == ID_REV_CHIP_ID_7800_) ||
@@ -2122,6 +2157,8 @@ static int lan78xx_phy_init(struct lan78xx_net *dev)
 		goto error;
 	}
 
+phyinit:
+
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(4, 9, 0)
 	/* if phyirq is not set, use polling mode in phylib */
 	if (dev->domain_data.phyirq > 0)
@@ -2667,8 +2704,13 @@ static int lan78xx_stop(struct net_device *net)
 	phy_unregister_fixup_for_uid(PHY_LAN8835, 0xfffffff0);
 
 	phy_stop(net->phydev);
-	phy_disconnect(net->phydev);
 
+	if (fixed_phy_device_present) {
+		fixed_phy_unregister(dev->net->phydev);
+		fixed_phy_device_present = false;
+	}
+
+	phy_disconnect(net->phydev);
 	net->phydev = NULL;
 
 	clear_bit(EVENT_DEV_OPEN, &dev->flags);
@@ -3574,7 +3616,6 @@ static void lan78xx_disconnect(struct usb_interface *intf)
 
 	net = dev->net;
 	unregister_netdev(net);
-
 	cancel_delayed_work_sync(&dev->wq);
 
 	usb_scuttle_anchored_urbs(&dev->deferred);
-- 
1.9.1

